package com.rockolo.wii
{
	import flash.events.*;
	import flash.events.EventDispatcher;
	import flash.net.Socket;
	import flash.events.Event;
	import flash.system.*;
	import flash.utils.ByteArray;
	import flash.events.ProgressEvent;
	import flash.utils.Dictionary;
	
	import com.rockolo.wii.WiiMote;
	
	[Event(name='connect', type='flash.events.Event')]
	[Event(name='newWiiMoteReally', type='flash.events.Event')]
	
	public class WiiClientSocket extends EventDispatcher
	{
		public static const HOST:String = "127.0.0.1";
		public static const PORT:uint = 7007;
		
		private static var instance:WiiClientSocket = new WiiClientSocket();
		private static var wiiMotes:Dictionary;
		private static var newWiimote:WiiMote;
		private static var socket:Socket;
		private static var address:ByteArray;
		private static var addressString:String;
		private static var wiiData:ByteArray;
		
		private var wiiMote:WiiMote;
		
		public static function getInstance():WiiClientSocket
		{
			return instance;
		}
		
		public static function getNewWiimote():WiiMote
		{
			return newWiimote;
		}
		
		public function WiiClientSocket()
		{
			if(! instance)
				init();
			
			if(instance)
				throw new Error("Error: Singleton-Class, use ClassName.getInstance()");	
		}
		
		private function init():void
		{
			wiiMotes = new Dictionary();
			address = new ByteArray();
			wiiData = new ByteArray();
			
			//create socket
			Security.allowDomain("*");	
			socket = new Socket();
			socket.addEventListener(Event.CONNECT, onSocketConnected);
			socket.connect(HOST, PORT);	
		}
		
		private function onSocketConnected(e:Event):void
		{
			trace("on socket connected");
			socket.addEventListener(ProgressEvent.SOCKET_DATA, handleSocketData);
		}
		
		private function handleSocketData(e:ProgressEvent):void
		{
			/*
			address of wiiMoteObject:	17 bytes
			button-info:				2  bytes
			acceleration:				12 bytes
			result:						31 bytes
			*/
			while(socket.bytesAvailable >= 31)
			{
				socket.readBytes(address, 0, 17);
				addressString = address.toString();
				
				if( ! wiiMotes.hasOwnProperty( addressString ) )
				{
					wiiMote = new WiiMote(addressString);
					wiiMotes[addressString] = wiiMote;
					
					newWiimote = wiiMote;
					this.dispatchEvent(new Event("newWiiMote"));
				}
				
				socket.readBytes(wiiData, 0, 2);
				
				var x:Number = socket.readFloat();
				var y:Number = socket.readFloat();
				var z:Number = socket.readFloat();
				
				(wiiMotes[addressString] as WiiMote).processData( wiiData, x, y, z );
			}
		}
		
		private function wiiMoteCalibrated(e:Event):void
		{
			newWiimote = wiiMote;
			this.dispatchEvent(new Event("newWiiMote"));
		}
		
	}
}