package com.rockolo.wii
{
	import flash.events.IEventDispatcher;
	import flash.events.EventDispatcher;
	import flash.events.Event;
	import flash.utils.ByteArray;
	import flash.utils.Timer;

	public class WiiMote extends EventDispatcher
	{
		public var address:String;
		
		private var _x:Number = 0;
		private var _y:Number = 0;
		private var _z:Number = 0;
		
		private var buttons0:Object;
		private var buttons1:Object;
		
		private var firstDigit:int;
		private var secondDigit:int;
		
		private var currentFirstButton:String = "";
		private var currentSecondButton:String = "";
		
		private static const ACCELERATION_CHANGED:String = 'accelerationChanged';
		
		private var accelerationChanged:Event = new Event( ACCELERATION_CHANGED );
		
		public function WiiMote(address:String)
		{
			address = address;
			trace("new WiiMote-Instance: " + address);
			
			buttons0 = {1 : 'Left', 2: 'Right', 4: 'Down', 8: 'Up', 16: 'Plus'};
			buttons1 = {1: 'Two', 2: 'One', 4: 'B', 8: 'A', 16: 'Minus', 128: 'Home'};
			
			
		}
		
		public function get x():Number
		{
			return _x;
		}
		
		public function get y():Number
		{
			return _y;
		}
		
		public function get z():Number
		{
			return _z;
		}
		
		public function processData(wiiData:ByteArray, x:Number, y:Number, z:Number):void
		{
			firstDigit = wiiData[0].valueOf();
			secondDigit = wiiData[1].valueOf();

	        if( buttons0[ firstDigit ] && buttons0[ firstDigit ] != currentFirstButton)
	        {
	            dispatchEvent( new Event( 'onPress' + buttons0[ firstDigit ] ) );
	            currentFirstButton = buttons0[ firstDigit ];
	        }
	        else if( currentFirstButton != '' && firstDigit == 0 )
			{
	            dispatchEvent( new Event( 'onRelease' + currentFirstButton ) );
	            currentFirstButton = '';
			}
	
	        if( buttons1[ secondDigit ] && buttons1[ secondDigit ] != currentSecondButton)
	        {
	            dispatchEvent( new Event( 'onPress' + buttons1[ secondDigit ] ) );
	            currentSecondButton = buttons1[ secondDigit ];
	        }
	        else if( currentSecondButton != '' && secondDigit == 0 )
			{
	            dispatchEvent( new Event( 'onRelease' + currentSecondButton ) );
	            currentSecondButton = '';
			}
			
			_x = x;
			_y = y;
			_z = z;
			
			dispatchEvent( accelerationChanged );

		}
		
	}
}